<?php
/**
 * Webkul MarketingCloud Magento Connector Import Controller
 * @category  Webkul
 * @package   Webkul_MarketingCloudMagentoConnector
 * @author    Webkul
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */
namespace Webkul\MarketingCloudMagentoConnector\Controller\Adminhtml\Subscriber;

use Magento\Backend\App\Action;
use Magento\Framework\Controller\ResultFactory;

class Import extends \Magento\Backend\App\Action
{
    protected $_scopeConfig;
        /**
         * @param Action\Context $context
         * @param Builder $productBuilder
         * @param \Magento\Catalog\Model\Indexer\Product\Price\Processor $productPriceIndexerProcessor
         * @param Filter $filter
         * @param CollectionFactory $collectionFactory
         */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Webkul\MarketingCloudMagentoConnector\Helper\Connection $connection,
        \Webkul\MarketingCloudMagentoConnector\Model\Subscriber $subscriberMapping,
        //\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Backend\Model\View\Result\ForwardFactory $resultForwardFactory
    ) {
        parent::__construct($context);
        $this->_subscriberMapping = $subscriberMapping;
        $this->_connection = $connection;
        //$this->_scopeConfig = $scopeConfig;
        $this->_resultForwardFactory = $resultForwardFactory;
        self::$scopeConfig = $this->_scopeConfig->getValue('marketingcloud/general/mc_conn_token');
    }

    public function execute()
    {
        $res = $this->_connection->importSubscriber();
        foreach($res[2] as $result){
            $collection = $this->_subscriberMapping->getCollection()
                                        ->addFieldToFilter('mc_subsId', ['eq' => $result['mc_subsId']]);
            if($collection->getSize() == 0){
                $this->_subscriberMapping->setData($result);
                $this->_subscriberMapping->save();
            }

        }
        $storeId = (int) $this->getRequest()->getParam('store', 0);
        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
        return  $resultRedirect->setPath('*/*/', ['store' => $storeId]);
    }

    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Webkul_MarketingCloudMagentoConnector::subscriber_list');
    }
}