<?php
/**
 * Webkul MarketingCloudMagentoConnector AdminSystemConfigSaveObserver Observer Model
 *
 * @category  Webkul
 * @package   Webkul_MarketingCloudMagentoConnector
 * @author    Webkul
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 *
 */
namespace Webkul\MarketingCloudMagentoConnector\Observer;

use Magento\Framework\Event\Manager;
use Magento\Framework\Event\ObserverInterface;
use Webkul\MarketingCloudMagentoConnector\Helper\Connection;

class AdminSystemConfigSaveObserver implements ObserverInterface
{
    public function __construct(
        \Magento\Framework\App\RequestInterface $requestInterface,
        \Magento\Framework\Message\ManagerInterface $messageManager,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Backend\Model\Session $session,
        \Webkul\MarketingCloudMagentoConnector\Helper\Connection $connection
    ) {
        $this->_connection = $connection;
        $this->_scopeConfig = $scopeConfig;
        $this->_session = $session;
        $this->_messageManager = $messageManager;
        $this->_requestInterface = $requestInterface;
    }

    /**
     * Sale Order Save After event handler
     *
     * @param \Magento\Framework\Event\Observer $observer
     * @return void
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $storeManager = $objectManager->get('\Magento\Store\Model\StoreManagerInterface');
        $sessionToken = $this->_session->getMarketingToken();
        $validate = $this->_connection->checkToken();
        $token = $this->_scopeConfig->getValue('marketingcloud/general/mc_conn_token');
        if ($validate) {
            if (isset($token) && $sessionToken == $token) {
                $this->_messageManager->addSuccess(__("Licence key is Valid!!!"));
            }
            else{
                $this->_messageManager->addSuccess(__("Licence key is Valid!!!"));
            }
            //$this->_messageManager->addSuccess(__("User is successfully validated!!!"));
        } else {
            $this->_messageManager->addError(__("Licence Key is Invalid, Kindly use correct licence key!!!"));
        }
    }
}
